package exParser;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.InputStreamReader;

/**
 * Created by IntelliJ IDEA.
 * User: AkiraSasaki
 * Date: 2008/06/01
 * Time: 18:11:27
 * To change this template use File | Settings | File Templates.
 */

public class ExParser {
	ExTokenizer s;
	TokenClass next;

	public ExParser(ExTokenizer sc) {
		s = sc;
		next = s.nextToken();
	}

    private void start(){
        E();
		if (s.nextToken() != TokenClass.EOF)
			throw new RuntimeException("parse error: EOF expected");
    }


    private void E() {
		T();
		E2();
	}

	private void E2() {
		if (next == TokenClass.PLUS) {
			next = s.nextToken();
			T();
			putSymbol("+");
			E2();
		}
		//@Fnextfollow(E2)̂ǂƂvȂ΃G[
	}

	private void T() {
		F();
		T2();
	}

	private void T2() {
		if (next == TokenClass.MULT) {
			next = s.nextToken();
			F();
			putSymbol("*");
			T2();
		}
	}

	private void F() {
		if (next == TokenClass.LPAR) {
			next = s.nextToken();
			E();
			if (next == TokenClass.RPAR)
				next = s.nextToken();
			else
				throw new RuntimeException("Parse error token=" + next);
		} else if (next == TokenClass.IDENT) {
			putSymbol(s.currentString());
			next = s.nextToken();
		}
	}

	private void putToken(TokenClass t) {
		System.out.print(" " + t);
	}

	private void putSymbol(String st) {
		System.out.print(" " + st);
	}

	public static void main(String[] args) throws Exception {
		BufferedReader reader = null;
		if (args.length == 1) {
			File input = new File(args[0]);
			if (!input.canRead()) {
				System.out.println("Error: could not read [" + input + "]");
			}
			reader = new BufferedReader(new FileReader(input));
		} else {
			reader = new BufferedReader(new InputStreamReader(System.in));
		}
		ExTokenizer s = new ExTokenizer(new CharReader(reader));
		ExParser p = new ExParser(s);
		try {
			p.start();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			reader.close();
		}
	}
}
